{
  Composition :
  When we hear HAS A and the contained object cannot be created without the container object we have COMPOSITION.
  Book HAS A Chapter(s). Chapters(contained object) cannot be created if Book(container) does not exist.
  Employee HAS A Document. Employee is composted by Document(s). A Document cannot be created without an employee.
  In C++ in Employee.h : list <Document> DocumentList;  //Document are passed by VALUE
  In Delphi in Employee.pas : DocumentList : TList;     //Document are passed by pointer
}

unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls,
  Employee;
  //Document not here !!! I CAN NOT create documents without an employee !!!

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonDeleteSelectedDocument: TButton;
    ButtonAddNewDocument: TButton;
    ButtonCount: TButton;
    ButtonAdd: TButton;
    ButtonModify: TButton;
    ButtonDelete: TButton;
    ButtonShow: TButton;
    ComboBoxDocumentIndex: TComboBox;
    ComboBoxSelectDocumentIndex: TComboBox;
    ComboBoxTipoNew: TComboBox;
    ComboBoxTipoNewDoc: TComboBox;
    ComboBoxTipoNewDoc1: TComboBox;
    EditDescriptionNew: TEdit;
    EditDescriptionNewDoc: TEdit;
    EditDescriptionNewDoc1: TEdit;
    EditIdModifyDoc: TEdit;
    EditIdDeleteDoc: TEdit;
    EditNameNew: TEdit;
    EditSurnameNew: TEdit;
    EditIdModify: TEdit;
    EditNameModify: TEdit;
    EditSurnameModify: TEdit;
    EditIdDelete: TEdit;
    GroupBoxSelectDocument2: TGroupBox;
    GroupBoxNewEmployee: TGroupBox;
    GroupBoxDeleteDocument: TGroupBox;
    GroupBoxModifyEmployee: TGroupBox;
    GroupBoxDeleteEmployee: TGroupBox;
    GroupBoxNewDocumentIn: TGroupBox;
    GroupBoxSelectDocument: TGroupBox;
    GroupBoxNewDocument: TGroupBox;
    GroupBoxDocument: TGroupBox;
    LabelEmployeeName: TLabel;
    LabelEmployeeSurname: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    LabelEmployeeWithID: TLabel;
    Label8: TLabel;
    LabelDocumentDescription3: TLabel;
    LabelDocumentIndex: TLabel;
    LabelDocumentDescription: TLabel;
    LabelDocumentDescription1: TLabel;
    LabelDocumentDescription2: TLabel;
    LabelDocumentIndex1: TLabel;
    LabelDocumentType: TLabel;
    LabelDocumentType1: TLabel;
    LabelDocumentType2: TLabel;
    LabelDocumentType3: TLabel;
    LabelNameDelete: TLabel;
    LabelNameNewDoc: TLabel;
    LabelNameDelDoc: TLabel;
    LabelSurnameDelete: TLabel;
    LabelSurnameNewDoc: TLabel;
    LabelSurnameDelDoc: TLabel;
    Memo: TMemo;
    procedure ButtonAddClick(Sender: TObject);
    procedure ButtonAddNewDocumentClick(Sender: TObject);
    procedure ButtonCountClick(Sender: TObject);
    procedure ButtonDeleteClick(Sender: TObject);
    procedure ButtonDeleteSelectedDocumentClick(Sender: TObject);
    procedure ButtonModifyClick(Sender: TObject);
    procedure ButtonShowClick(Sender: TObject);
    procedure ComboBoxDocumentIndexChange(Sender: TObject);
    procedure ComboBoxSelectDocumentIndexChange(Sender: TObject);
    procedure EditIdDeleteChange(Sender: TObject);
    procedure EditIdModifyChange(Sender: TObject);
    procedure EditIdDeleteDocChange(Sender: TObject);
    procedure EditIdModifyDocChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);




  private
    { private declarations }


    EmployeeList : TList; //list of objects of employees (list of TEmployeee)

    procedure addEmployee(Emp: TEmployee);
    procedure deleteEmployee(index:integer);
    function FindEmployeeWithId(id:integer) : TEmployee;
    procedure DeleteEmployeeWithId(id:integer);


  public
    { public declarations }
    function getEmployee(index: integer): TEmployee;

  end; 

var
  Form1: TForm1;

implementation


{ TForm1 }

//List operations...
procedure TForm1.addEmployee(Emp: TEmployee);
begin
  EmployeeList.Add(Emp); //ALWAYS ADDS AT LAST ELEMENT
end;

function TForm1.getEmployee(index:integer): TEmployee;
begin

  if EmployeeList.Items[index] <> nil then begin
    result:=TEmployee(EmployeeList.Items[index]); //Casting. tlist.item is an employee object !!!
  end else result:=nil;

end;

procedure TForm1.deleteEmployee(index:integer);
begin
  if EmployeeList.Items[index] <> nil then begin
     TEmployee(EmployeeList.Items[index]).Destroy; //Destroy object (Casting)
     EmployeeList.Delete(index);                   //Destroy cell of tlist
  end;
end;


//extras...
function TForm1.FindEmployeeWithId(id:integer) : TEmployee;
var i,imax:integer;
begin
  imax:=TEmployee.CountEmployees - 1; //INVOICE CLASS METHOD !!!
  result := nil;
  for i:=0 to imax do begin
    if TEmployee(EmployeeList.Items[i]).GetId = id then begin
      result := TEmployee(EmployeeList.Items[i]);
      break;
    end;
  end;
end;

procedure TForm1.DeleteEmployeeWithId(id:integer);
var i,imax:integer;
begin
  imax:=TEmployee.CountEmployees - 1; //INVOICE CLASS METHOD !!!
  for i:=0 to imax do begin
    if TEmployee(EmployeeList.Items[i]).GetId = id then begin
      deleteEmployee(i);
      break;
    end;
  end;
end;

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
///////////////////////////EVENTS/////////////////////////////////////////////

//add employee event
procedure TForm1.ButtonAddClick(Sender: TObject);
var Emp_Obj : TEmployee;
begin

   //CREATE A NEW EMPLOYEE OBJECT
   Emp_Obj := TEmployee.Create(EditNameNew.Text,EditSurnameNew.Text,ComboBoxTipoNew.Text,EditDescriptionNew.Text);

   self.addEmployee(Emp_Obj);

   showmessage('Employee with this info : ' + Emp_Obj.PrintMe() + ' added into TList.');

end;


//add new document in a selected employee
procedure TForm1.ButtonAddNewDocumentClick(Sender: TObject);
var EmpTemp : TEmployee;
begin
  EmpTemp := FindEmployeeWithId(strtoint(EditIdModifyDoc.Text));
  if EmpTemp <> nil then begin
    EmpTemp.SetDocument(ComboBoxTipoNewDoc.text,EditDescriptionNewDoc.text);
  end;
   showmessage('Employee with this info : ' + EmpTemp.PrintMe() + ' updated (added more documents).');
end;


//modify selected employee
procedure TForm1.ButtonModifyClick(Sender: TObject);
var EmpTemp : TEmployee;
begin
  EmpTemp := FindEmployeeWithId(strtoint(EditIdModify.Text));
  if EmpTemp <> nil then begin
      EmpTemp.SetName(EditNameModify.Text);
      EmpTemp.SetSurname(EditSurnameModify.Text);
      EmpTemp.GetDocument(ComboBoxDocumentIndex.ItemIndex).SetTipo(ComboBoxTipoNewDoc1.Text);
      EmpTemp.GetDocument(ComboBoxDocumentIndex.ItemIndex).SetDescription(EditDescriptionNewDoc1.Text);
      showmessage('Employee with this info : ' + EmpTemp.PrintMe() + ' modifided.');
  end;
end;

//delete selected employee (and the tlist cell !!!)
procedure TForm1.ButtonDeleteClick(Sender: TObject);
var EmpTemp : TEmployee;
begin
  DeleteEmployeeWithId(strtoint(EditIdDelete.Text));
end;

//Delete from an selected employee a selected document
procedure TForm1.ButtonDeleteSelectedDocumentClick(Sender: TObject);
var EmpTemp : TEmployee;
    i,imax : integer;
begin
  EmpTemp := FindEmployeeWithId(strtoint(EditIdDeleteDoc.Text));
  if EmpTemp <> nil then begin
      EmpTemp.GetDocument(ComboBoxSelectDocumentIndex.ItemIndex).Destroy;  //DELETE DOCUMENT
      EmpTemp.GetDocuments.Delete(ComboBoxSelectDocumentIndex.ItemIndex);  //DELETE CELL OF DOCUMENT LIST

      //refresh...
      ComboBoxSelectDocumentIndex.Clear;
      imax := EmpTemp.GetDocuments.Count - 1;
      for i:=0 to imax do begin
         ComboBoxSelectDocumentIndex.Items.Add(inttostr(i+1));
      end;
      ComboBoxSelectDocumentIndex.ItemIndex:=0;
      LabelDocumentType3.Caption := EmpTemp.GetDocument(ComboBoxSelectDocumentIndex.ItemIndex).GetTipo;
      LabelDocumentDescription3.Caption := EmpTemp.GetDocument(ComboBoxSelectDocumentIndex.ItemIndex).GetDescription;
      //Each employee must have AT LEAST ONE Document (COMPOSITION !!!)
      if imax>=1 then ButtonDeleteSelectedDocument.Enabled := true else ButtonDeleteSelectedDocument.Enabled := false;
  end;
end;

//show all employees
procedure TForm1.ButtonShowClick(Sender: TObject);
 var i,imax:integer;
begin
  memo.Clear;

  imax:=TEmployee.CountEmployees - 1; //INVOICE CLASS METHOD !!!

  for i:=0 to imax do begin
    Memo.Lines.Add(getEmployee(i).PrintMe);
  end;

end;

//on change combobox on modify employee ...
procedure TForm1.ComboBoxDocumentIndexChange(Sender: TObject);
var EmpTemp : TEmployee;
begin
  EmpTemp := FindEmployeeWithId(strtoint(EditIdModify.Text));
  if EmpTemp <> nil then begin
    ComboBoxTipoNewDoc1.Text := EmpTemp.GetDocument(ComboBoxDocumentIndex.ItemIndex).GetTipo;
    EditDescriptionNewDoc1.Text := EmpTemp.GetDocument(ComboBoxDocumentIndex.ItemIndex).GetDescription;
  end;
end;

//on change combobox on delete document ...
procedure TForm1.ComboBoxSelectDocumentIndexChange(Sender: TObject);
var EmpTemp : TEmployee;
begin
  EmpTemp := FindEmployeeWithId(strtoint(EditIdDeleteDoc.Text));
  if EmpTemp <> nil then begin
    LabelDocumentType3.Caption := EmpTemp.GetDocument(ComboBoxSelectDocumentIndex.ItemIndex).GetTipo;
    LabelDocumentDescription3.Caption := EmpTemp.GetDocument(ComboBoxSelectDocumentIndex.ItemIndex).GetDescription;
  end;
end;

//Count employee objects
procedure TForm1.ButtonCountClick(Sender: TObject);
begin
  showmessage('I have ' + inttostr(TEmployee.CountEmployees) + ' employees'); //Class method !!!
end;



//Find employee to modify
procedure TForm1.EditIdModifyChange(Sender: TObject);
var EmpTemp : TEmployee;
    i,imax : integer;
begin
  EmpTemp := FindEmployeeWithId(strtoint(EditIdModify.Text));
  if EmpTemp <> nil then begin
    EditNameModify.Text := EmpTemp.GetName;
    EditSurnameModify.Text := EmpTemp.GetSurname;
    ButtonModify.Enabled:=true;

    //Update ComboBoxDocumentIndex
    imax := EmpTemp.GetDocuments.Count-1;
    ComboBoxDocumentIndex.Clear;
    for i:=0 to imax do begin
      ComboBoxDocumentIndex.Items.Add(inttostr(i+1));
    end;
    ComboBoxDocumentIndex.ItemIndex := 0; //Set Index=1
    ComboBoxDocumentIndex.Enabled := true;
    ComboBoxTipoNewDoc1.Text := EmpTemp.GetDocument(ComboBoxDocumentIndex.ItemIndex).GetTipo;
    EditDescriptionNewDoc1.Text := EmpTemp.GetDocument(ComboBoxDocumentIndex.ItemIndex).GetDescription;

  end else begin
    EditNameModify.Text := 'N/A';
    EditSurnameModify.Text := 'N/A';
    ButtonModify.Enabled:=false;
    ComboBoxDocumentIndex.Enabled := false;
  end;
end;

//On change id on the Delete document
procedure TForm1.EditIdDeleteDocChange(Sender: TObject);
var EmpTemp : TEmployee;
    i,imax : integer;
begin
  EmpTemp := FindEmployeeWithId(strtoint(EditIdDeleteDoc.Text));
  if EmpTemp <> nil then begin
    LabelNameDelDoc.Caption := EmpTemp.GetName;
    LabelSurnameDelDoc.Caption := EmpTemp.GetSurname;
    ButtonDeleteSelectedDocument.Enabled:=true;
    ComboBoxSelectDocumentIndex.Enabled := true;

    //Update ComboBoxSelectDocumentIndex
    imax := EmpTemp.GetDocuments.Count-1;
    ComboBoxSelectDocumentIndex.Clear;
    for i:=0 to imax do begin
      ComboBoxSelectDocumentIndex.Items.Add(inttostr(i+1));
    end;
    ComboBoxSelectDocumentIndex.Enabled := true;
    ComboBoxSelectDocumentIndex.ItemIndex := 0; //Set Index=1
    LabelDocumentType3.Caption := EmpTemp.GetDocument(ComboBoxSelectDocumentIndex.ItemIndex).GetTipo;
    LabelDocumentDescription3.Caption := EmpTemp.GetDocument(ComboBoxSelectDocumentIndex.ItemIndex).GetDescription;

    //Each employee must have AT LEAST ONE Document (COMPOSITION !!!)
    if imax>=1 then ButtonDeleteSelectedDocument.Enabled := true else ButtonDeleteSelectedDocument.Enabled := false;

  end else begin
    LabelNameDelDoc.Caption := 'N/A';
    LabelSurnameDelDoc.Caption := 'N/A';
    ButtonDeleteSelectedDocument.Enabled:=false;
    ComboBoxSelectDocumentIndex.Enabled := false;
  end;
end;

//On change id on the new document
procedure TForm1.EditIdModifyDocChange(Sender: TObject);
var EmpTemp : TEmployee;
begin
  EmpTemp := FindEmployeeWithId(strtoint(EditIdModifyDoc.Text));
  if EmpTemp <> nil then begin
    LabelNameNewDoc.Caption := EmpTemp.GetName;
    LabelSurnameNewDoc.Caption := EmpTemp.GetSurname;
    ButtonAddNewDocument.Enabled:=true;
  end else begin
    LabelNameNewDoc.Caption  := 'N/A';
    LabelSurnameNewDoc.Caption := 'N/A';
    ButtonAddNewDocument.Enabled:=false;
  end;
end;

//Find employee to delete
procedure TForm1.EditIdDeleteChange(Sender: TObject);
var EmpTemp : TEmployee;
begin
  EmpTemp := FindEmployeeWithId(strtoint(EditIdDelete.Text));
  if EmpTemp <> nil then begin
    LabelNameDelete.Caption := EmpTemp.GetName;
    LabelSurnameDelete.Caption := EmpTemp.GetSurname;
    ButtonDelete.Enabled:=true;
  end else begin
    LabelNameDelete.Caption  := 'N/A';
    LabelSurnameDelete.Caption := 'N/A';
    ButtonDelete.Enabled:=false;
  end;
end;



//On create form
procedure TForm1.FormCreate(Sender: TObject);
begin
  EmployeeList := TList.Create; //Create the list !!!
end;

//On Exit form
procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var i,imax:integer;
begin
  imax:=EmployeeList.count-1;
  for i:=imax downto 0 do begin
   TEmployee(EmployeeList[i]).Destroy ;
   EmployeeList.Delete(i) ;
  end;
  EmployeeList.Free;  //Destroy the list !!!
end;



initialization
  {$I unit1.lrs}

end.

